package de.oaa.xxx.aufgaben.entity;

import de.oaa.xxx.aufgaben.Strafe;
import de.oaa.xxx.aufgaben.Werkzeug;
import jakarta.persistence.CascadeType;
import jakarta.persistence.CollectionTable;
import jakarta.persistence.Column;
import jakarta.persistence.ElementCollection;
import jakarta.persistence.Entity;
import jakarta.persistence.EnumType;
import jakarta.persistence.Enumerated;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.JoinTable;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

import java.util.List;
import java.util.UUID;

@Entity
@Table(name = "strafe")
public class StrafeEntity {

    @Id
    @Column
    private UUID strafeId;
    @Column
    private String kurzText;
    @Column
    private Integer level;
    @Column(columnDefinition = "TEXT")
    private String text;
    @Column
    private Integer sekundenVon;
    @Column
    private Integer sekundenBis;
    @ManyToOne
    @JoinColumn(name = "gruppeId")
    private AufgabenGruppeEntity aufgabenGruppe;
    @Enumerated(EnumType.STRING)
    @ElementCollection(targetClass = Werkzeug.class)
    @CollectionTable(name = "strafe_benoetigtAktiv", joinColumns = @JoinColumn(name = "strafeId"))
    @Column(name = "werkzeug")
    private List<Werkzeug> benoetigtAktiv;
    @Enumerated(EnumType.STRING)
    @ElementCollection(targetClass = Werkzeug.class)
    @CollectionTable(name = "strafe_benoetigtPassiv", joinColumns = @JoinColumn(name = "strafeId"))
    @Column(name = "werkzeug")
    private List<Werkzeug> benoetigtPassiv;
    @ManyToMany(cascade = CascadeType.DETACH)
    @JoinTable(name = "strafeToy", joinColumns = {@JoinColumn(name = "strafeId")}, inverseJoinColumns = {@JoinColumn(name = "toyId")})
    private List<ToyEntity> benoetigteToys;

    public UUID getStrafeId() { return strafeId; }
    public void setStrafeId(UUID strafeId) { this.strafeId = strafeId; }

    public String getKurzText() { return kurzText; }
    public void setKurzText(String kurzText) { this.kurzText = kurzText; }

    public Integer getLevel() { return level; }
    public void setLevel(Integer level) { this.level = level; }

    public String getText() { return text; }
    public void setText(String text) { this.text = text; }

    public Integer getSekundenVon() { return sekundenVon; }
    public void setSekundenVon(Integer sekundenVon) { this.sekundenVon = sekundenVon; }

    public Integer getSekundenBis() { return sekundenBis; }
    public void setSekundenBis(Integer sekundenBis) { this.sekundenBis = sekundenBis; }

    public AufgabenGruppeEntity getAufgabenGruppe() { return aufgabenGruppe; }
    public void setAufgabenGruppe(AufgabenGruppeEntity aufgabenGruppe) { this.aufgabenGruppe = aufgabenGruppe; }

    public List<Werkzeug> getBenoetigtAktiv() { return benoetigtAktiv; }
    public void setBenoetigtAktiv(List<Werkzeug> benoetigtAktiv) { this.benoetigtAktiv = benoetigtAktiv; }

    public List<Werkzeug> getBenoetigtPassiv() { return benoetigtPassiv; }
    public void setBenoetigtPassiv(List<Werkzeug> benoetigtPassiv) { this.benoetigtPassiv = benoetigtPassiv; }

    public List<ToyEntity> getBenoetigteToys() { return benoetigteToys; }
    public void setBenoetigteToys(List<ToyEntity> benoetigteToys) { this.benoetigteToys = benoetigteToys; }

    public Strafe toStrafe() {
        Strafe strafe = new Strafe();
        strafe.setStrafeId(strafeId);
        strafe.setBenoetigtAktiv(benoetigtAktiv);
        strafe.setBenoetigteToys(benoetigteToys.stream().map(ToyEntity::toToy).toList());
        strafe.setBenoetigtPassiv(benoetigtPassiv);
        strafe.setGruppeId(aufgabenGruppe.getGruppenId());
        strafe.setKurzText(kurzText);
        strafe.setLevel(level);
        strafe.setSekundenBis(sekundenBis);
        strafe.setSekundenVon(sekundenVon);
        strafe.setText(text);
        return strafe;
    }

    public static StrafeEntity create(Strafe strafe, AufgabenGruppeEntity aufgabenGruppeEntity) {
        StrafeEntity entity = new StrafeEntity();
        entity.setStrafeId(UUID.randomUUID());
        entity.setAufgabenGruppe(aufgabenGruppeEntity);
        entity.setBenoetigtAktiv(strafe.getBenoetigtAktiv());
        entity.setBenoetigteToys(strafe.getBenoetigteToys().stream().map(toy -> ToyEntity.create(toy, aufgabenGruppeEntity)).toList());
        entity.setBenoetigtPassiv(strafe.getBenoetigtPassiv());
        entity.setKurzText(strafe.getKurzText());
        entity.setLevel(strafe.getLevel());
        entity.setSekundenBis(strafe.getSekundenBis());
        entity.setSekundenVon(strafe.getSekundenVon());
        entity.setText(strafe.getText());
        return entity;
    }
}
